love.graphics.setDefaultFilter("nearest", "nearest")

local tileset = love.graphics.newImage('border-tiles.png')

local quads = {}
local air

do
  local function gen_quad(idx)
    local x = idx % 8
    local y = (idx - x) / 8
    return love.graphics.newQuad(x*8, y*8, 8, 8, tileset:getDimensions())
  end

  air = gen_quad(47)

  -- The first 20 elements are correctly numbered
  for i = 0x00, 0x13 do
    quads[i] = gen_quad(i)
  end
  -- 0x14-0x1F are missing
  quads[0x20] = gen_quad(20)
  quads[0x21] = gen_quad(21)
  -- 0x22-0x23 are missing
  quads[0x24] = gen_quad(22)
  quads[0x25] = gen_quad(23)
  -- 0x26-0x2F are missing
  quads[0x30] = gen_quad(24)
  quads[0x31] = gen_quad(25)
  -- 0x32-0x3F are missing
  quads[0x40] = gen_quad(26)
  -- 0x41-0x43 are missing
  quads[0x44] = gen_quad(27)
  -- 0x45-0x47 are missing
  quads[0x48] = gen_quad(28)
  -- 0x49-0x4B are missing
  quads[0x4C] = gen_quad(29)
  -- 0x4D-0x4F are missing
  quads[0x50] = gen_quad(30)
  -- 0x51-0x5F are missing
  quads[0x60] = gen_quad(31)
  -- 0x61-0x63 are missing
  quads[0x64] = gen_quad(32)
  -- 0x65-0x6F are missing  
  quads[0x70] = gen_quad(33)
  -- 0x71-0x7F are missing
  quads[0x80] = gen_quad(34)
  -- 0x81 is missing
  quads[0x82] = gen_quad(35)
  -- 0x83-0x87 are missing
  quads[0x88] = gen_quad(36)
  -- 0x89 is missing
  quads[0x8A] = gen_quad(37)
  -- 0x8B-0x8F are missing
  quads[0x90] = gen_quad(38)
  -- and so on
  quads[0x92] = gen_quad(39)
  quads[0xA0] = gen_quad(40)
  quads[0xB0] = gen_quad(41)
  quads[0xC0] = gen_quad(42)
  quads[0xC8] = gen_quad(43)
  quads[0xD0] = gen_quad(44)
  quads[0xE0] = gen_quad(45)
  quads[0xF0] = gen_quad(46)
end

local map = {}

for i = 1, 100*75 do
  map[i] = math.random(0, 99) < 40 and 1 or 0
end

local canvas = love.graphics.newCanvas()
love.graphics.setCanvas(canvas)

for y = 0, 74 do
  for x = 0, 99 do
    local idx = y * 100 + x + 1
    if map[y * 100 + x + 1] == 1 then
      local bin = 0
      local u = y ==  0 and 0 or map[idx - 100]
      local d = y == 74 and 0 or map[idx + 100]
      local l = x ==  0 and 0 or map[idx - 1]
      local r = x == 99 and 0 or map[idx + 1]

      if u == 0 then bin = bin + 0x10 end
      if d == 0 then bin = bin + 0x40 end
      if l == 0 then bin = bin + 0x80 end
      if r == 0 then bin = bin + 0x20 end
      if u == 1 and l == 1 and map[idx - 101] == 0 then bin = bin + 0x04 end
      if u == 1 and r == 1 and map[idx -  99] == 0 then bin = bin + 0x08 end
      if d == 1 and l == 1 and map[idx +  99] == 0 then bin = bin + 0x01 end
      if d == 1 and r == 1 and map[idx + 101] == 0 then bin = bin + 0x02 end
      love.graphics.draw(tileset, quads[bin], x*8, y*8)
    else
      love.graphics.draw(tileset, air, x*8, y*8)
    end
  end
end

love.graphics.setCanvas()

function love.draw()
  love.graphics.draw(canvas)
end

function love.keypressed(k) return k == "escape" and love.event.quit() end
